import sys
import argparse

#para for GAT
def get_args():
    parser = argparse.ArgumentParser('GAT')
    parser.add_argument('--sample-type', type=str, default='uniform_sample',
                        help='the type of sample')
    parser.add_argument('--p1',default=0.0, type=float, help='the value of parameter p1')
    parser.add_argument('--p2',default=1.0, type=float, help='the value of parameter p2')
    parser.add_argument('--q', default=0.5,type=float, help='the value of parameter q')
    parser.add_argument('--lambda_',default=1.0, type=float, help='the value of parameter lambda')
    parser.add_argument('--lambda_', default=1.0,type=float, help='the value of parameter lambda')
    parser.add_argument('--model-name', type=str,
                        choices=['gcn', 'gat', 'graphsage'],
                        help='the name of model')
    parser.add_argument("--gpu", type=int, default=-1,
                        help="which GPU to use. Set -1 to use CPU.")
    parser.add_argument('--dataset', type=str,
                        help='the name of dataset')
    parser.add_argument("--out-head", type=int, default=1,
                        help="number of output attention heads")
    parser.add_argument("--heads", type=str, default='8',
                        help="list of the numbers of heads splited by '-' ")
    parser.add_argument("--hidden-dims", type=str, default='8',
                        help="list of the numbers of heads splited by '-' ")
    parser.add_argument("--residual", action="store_true", default=False,
                        help="use residual connection")
    parser.add_argument("--bias", action="store_true", default=False,
                        help="use bias")
    parser.add_argument("--feat-drop", type=float, default=.0,
                        help="input feature dropout")
    parser.add_argument("--attn-drop", type=float, default=.0,
                        help="attention dropout")
    parser.add_argument('--negative-slope', type=float, default=0.2,
                        help="the negative slope of leaky relu")
    parser.add_argument("--epochs", type=int, default=100,
                        help="number of training epochs")
    parser.add_argument("--lr", type=float, default=0.005,
                        help="learning rate")
    parser.add_argument('--weight-decay', type=float, default=5e-4,
                        help="weight decay")
    args = parser.parse_args()
    return args


# para for GraphSAGE
def get_args2():
    parser = argparse.ArgumentParser('sage')
    parser.add_argument('--sample-type', type=str, default='uniform_sample',
                        help='the type of sample')
    parser.add_argument('--p1',default=0.0, type=float, help='the value of parameter p1')
    parser.add_argument('--p2',default=1.0, type=float, help='the value of parameter p2')
    parser.add_argument('--q', default=0.5,type=float, help='the value of parameter q')
    parser.add_argument('--lambda_',default=1.0, type=float, help='the value of parameter lambda')
    parser.add_argument('--uniform-ratio', default='1.0', type=float, help='the ratio of uniform sampling')
    parser.add_argument('--model-name', type=str,
                        choices=['gcn', 'gat', 'graphsage'],
                        help='the name of model')
    parser.add_argument("--gpu", type=int, default=-1,
                        help="which GPU to use. Set -1 to use CPU.")

    parser.add_argument('--dataset', type=str, default='cora',
                        help='the name of dataset')

    parser.add_argument("--hidden-dims", type=str, default='16',
                        help="list of the numbers of heads splited by '-' ")

    parser.add_argument("--bias", action="store_true", default=False,
                        help="use bias")
    parser.add_argument("--feat-drop", type=float, default=.0,
                        help="input feature dropout")

    parser.add_argument("--epochs", type=int, default=200,
                        help="number of training epochs")
    parser.add_argument("--lr", type=float, default=0.01,
                        help="learning rate")
    parser.add_argument('--weight-decay', type=float, default=5e-4,
                        help="weight decay")
    args = parser.parse_args()
    return args


# para for GCN
def get_args3():
    parser = argparse.ArgumentParser('GCN')
    parser.add_argument('--sample-type', type=str, default='uniform_sample',
                        help='the type of sample')
    parser.add_argument('--p1',default=0.0, type=float, help='the value of parameter p1')
    parser.add_argument('--p2',default=1.0, type=float, help='the value of parameter p2')
    parser.add_argument('--q', default=0.5,type=float, help='the value of parameter q')
    parser.add_argument('--lambda_',default=1.0, type=float, help='the value of parameter lambda')
    parser.add_argument('--uniform-ratio', default='1.0', type=float, help='the ratio of uniform sampling')
    parser.add_argument('--model-name', type=str,
                        help='the name of model')
    parser.add_argument("--gpu", type=int, default=-1,
                        help="which GPU to use. Set -1 to use CPU.")

    parser.add_argument('--dataset', type=str,
                        help='the name of dataset')

    parser.add_argument("--hidden-dims", type=str, default='16',
                        help="list of the numbers of heads splited by '-' ")

    parser.add_argument("--bias", action="store_true", default=False,
                        help="use bias")
    parser.add_argument("--feat-drop", type=float, default=.0,
                        help="input feature dropout")

    parser.add_argument("--epochs", type=int, default=200,
                        help="number of training epochs")
    parser.add_argument("--lr", type=float, default=0.01,
                        help="learning rate")
    parser.add_argument('--weight-decay', type=float, default=5e-4,
                        help="weight decay")
    args = parser.parse_args()
    return args


# para for JKNET
def get_args4():
    parser = argparse.ArgumentParser(description='JKNet')

    parser.add_argument('--sample-type', type=str, default='uniform_sample',
                        help='the type of sample')
    parser.add_argument('--p1',default=0.0, type=float, help='the value of parameter p1')
    parser.add_argument('--p2',default=1.0, type=float, help='the value of parameter p2')
    parser.add_argument('--q', default=0.5,type=float, help='the value of parameter q')
    parser.add_argument('--lambda_',default=1.0, type=float, help='the value of parameter lambda')
    parser.add_argument('--uniform-ratio', default='1.0', type=float, help='the ratio of uniform sampling')
    parser.add_argument('--model-name', type=str,
                        choices=['gcn', 'gat', 'graphsage', 'jknet'],
                        help='the name of model')

    # data source params
    parser.add_argument('--dataset', type=str, help='Name of dataset.')
    # cuda params
    parser.add_argument('--gpu', type=int, default=-1, help='GPU index. Default: -1, using CPU.')
    # training params
    parser.add_argument('--epochs', type=int, default=500, help='Training epochs.')
    parser.add_argument('--lr', type=float, default=0.005, help='Learning rate.')
    parser.add_argument('--lamb', type=float, default=0.0005, help='L2 reg.')
    # model params
    parser.add_argument("--hid-dim", type=int, default=32, help='Hidden layer dimensionalities.')
    parser.add_argument("--num-layers", type=int, default=5, help='Number of GCN layers.')
    parser.add_argument("--mode", type=str, default='cat', help="Type of aggregation.", choices=['cat', 'max', 'lstm'])
    parser.add_argument("--dropout", type=float, default=0.5, help='Dropout applied at all layers.')

    args = parser.parse_args()
    return args