import dgl.data as dgl_data

def get_dataset(data_name,device):
    if data_name in ['cora', 'citeseer', 'pubmed']:
        if data_name == 'cora':
            data = dgl_data.CoraGraphDataset()
        elif data_name == 'citeseer':
            data = dgl_data.CiteseerGraphDataset()
        elif data_name == 'pubmed':
            data = dgl_data.PubmedGraphDataset()
        g = data[0].to(device)
        num_feats = g.ndata['feat'].shape[1]
        n_classes = data.num_labels
        n_edges = g.num_edges()
        n_nodes = g.num_nodes()
        print('dim of feats:{}, classes{}, edges: {}, nodes: {} '.format(
            num_feats, n_classes, n_edges, n_nodes))
        return g, num_feats, n_classes

