import torch as th
import numpy as np


class sampler:
    def __init__(self, g):
        self.g = g
        self.device = g.device

    def uniform_sample(self, prob):
        indices = th.tensor(prob).to(self.device) - th.tensor(np.random.random([self.g.num_edges()])).to(
            self.device)
        sampled_edges = th.arange(0, self.g.num_edges())[indices > 0].to(self.device)
        indices = indices.to('cpu')
        return self.g.to('cpu').edge_subgraph(sampled_edges.to('cpu')).to(self.device), len(indices[indices > 0]) / len(
            indices)

    def gds(self, p1=0., p2=1., q=0.5, lambda_=1.0):
        q = th.tensor(q).float().to(self.device)
        ave = self.g.ndata['feat'].mean(dim=0, keepdim=True)
        Sigma = (self.g.ndata['feat'] - ave).pow(2).sum() / self.g.ndata['feat'].shape[0] * lambda_
        self.g.ndata['degree'] = self.g.in_degrees() + self.g.out_degrees()

        self.g.apply_edges(lambda edges: {'x': (Sigma + (edges.src['feat'] - edges.dst['feat']).pow(2).sum(1))\
                                               *(1.0 / edges.src['degree'] + 1.0 / edges.dst['degree'])})

        quantile = th.quantile(self.g.edata['x'], q)
        high_prob_index = self.g.edata['x'] >= quantile
        prob = th.ones([self.g.num_edges()]) * p1
        prob = prob.to(self.device)
        prob[high_prob_index] = p2

        indices = prob - th.tensor(np.random.random([self.g.num_edges()])).to(
            self.device)
        sampled_edges = th.arange(0, self.g.num_edges())[indices > 0].to(self.device)
        return self.g.to('cpu').edge_subgraph(sampled_edges.to('cpu')).to(self.device), sum(
            indices.to('cpu') > 0) / len(indices)

